<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 0;
var currentStep = 1;
var runParametersIsValid = false;

var runParameters;
var flowCell;

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
}


function step1IsValid()
{
	return runParametersIsValid;
}


function init()
{
	var frm = document.forms['reggie'];
	
	// Load sequencing protocols
	var sequencingProtocols = getProtocols('SEQUENCING_PROTOCOL');
	for (var i = 0; i < sequencingProtocols.length; i++)
	{
		var protocol = sequencingProtocols[i];
		frm.sequencingProtocol[frm.sequencingProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('sequencingProtocol', '', 'valid');
	}
	if (frm.sequencingProtocol.length == 0)
	{
		frm.sequencingProtocol[0] = new Option('- none -', '');
	}
	
	// Load sequencing machines
	var sequencers = getHardware('SEQUENCER');
	for (var i = 0; i < sequencers.length; i++)
	{
		var sequencer = sequencers[i];
		frm.sequencer[frm.sequencer.length] = new Option(sequencer.name, sequencer.id, sequencer.isDefault);
		setInputStatus('sequencer', '', 'valid');
	}
	if (frm.sequencer.length == 0)
	{
		frm.sequencer[0] = new Option('- none -', '');
	}
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function getHardware(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' hardware...');
		var url = '../Hardware.servlet?ID=<%=ID%>&cmd=GetHardware&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.hardware;
}


function runParametersXmlFileOnChange(event)
{
	var frm = document.forms['reggie'];
	var file = event.target.files[0];
	
	// Clear information
	setInnerHTML('experimentName', '');
	setInnerHTML('externalId', '');
	setInnerHTML('runId', '');
	setInnerHTML('position', '');
	setInnerHTML('runNumber', '');
	setInnerHTML('startDate', '');
	setInnerHTML('sequencingCycles', '');
	setInnerHTML('flowCellName', 'Flow cell information');
	setInnerHTML('pools', '');
	setInnerHTML('libPlate', '');
	Main.hide('existing-sequencing-runs');
	setInnerHTML('existing-sequencing-runs', '');
	setInputStatus('sequencingCycles', '', '');
	
	var reader = new FileReader();
	reader.onload = runParametersXmlFileLoaded;
	reader.readAsText(file);
}

function runParametersXmlFileLoaded(event)
{
	parseRunParametersXmlFile(event.target.result);
	var frm = document.forms['reggie'];
	frm.comments.focus();
}


function parseRunParametersXmlFile(data)
{
	var frm = document.forms['reggie'];
	runParametersIsValid = false;
	setInputStatus('runParametersXml', '', '');
	
	var doc;
	try
	{
		var parser = new DOMParser();
		doc = parser.parseFromString(data, "application/xml");
	
		if (doc.documentElement.tagName == 'parsererror')
		{
			setInputStatus('runParametersXml', doc.documentElement.firstChild.textContent.split(/\n/)[0], 'invalid');
			return;
		}
	}
	catch (err)
	{
		setInputStatus('runParametersXml', err, 'invalid');
		return;
	}
	
	var info = {};
	try
	{
		info.ExperimentName = getTextValue(doc, 'ExperimentName');
		info.RunID = getTextValue(doc, 'RunID');
		info.HiSeqPosition = getTextValue(doc, 'FCPosition');
		info.ScannerID = getTextValue(doc, 'ScannerID');
		info.ScanNumber = parseInt(getTextValue(doc, 'ScanNumber'));
		info.FlowCellID = getTextValue(doc, 'Barcode');
		info.SequencingCycles = getTextValue(doc, 'Read1') + '-' + getTextValue(doc, 'IndexRead1') + '-' + getTextValue(doc, 'Read2');
		info.SequencingStart = '20'+getTextValue(doc, 'RunStartDate');

		validateAndCopyRunParameters(info);
	}
	catch (msg)
	{
		setInputStatus('runParametersXml', msg, 'invalid');
		if (debug) Main.debug(JSON.stringify(info));
		return;
	}
	
	runParametersIsValid = true;
	runParameters = info;
	setInputStatus('runParametersXml', '', 'valid');

	if (debug) Main.debug(JSON.stringify(info));
}


function getTextValue(doc, selector)
{
	var el = doc.querySelector(selector);
	if (el == null)
	{
		throw "Can't find tag &lt;"+selector+"&gt;";
	}
	return el.textContent;
}

function validateAndCopyRunParameters(info)
{
	var frm = document.forms['reggie'];

	setInnerHTML('experimentName', info.ExperimentName);
	setInnerHTML('externalId', info.FlowCellID);
	setInnerHTML('runId', info.RunID);
	setInnerHTML('position', info.HiSeqPosition);
	setInnerHTML('runNumber', info.ScanNumber);
	setInnerHTML('startDate', formatDate(info.SequencingStart));
	setInnerHTML('sequencingCycles', info.SequencingCycles);

	flowCell = getFlowCellInfoByBarcode(info.FlowCellID);
	if (flowCell == null)
	{
		setInnerHTML('flowCellName', 'Can\'t find flow cell ' + info.FlowCellID);
		throw 'Flow cell with ID='+info.FlowCellID+' not found.';
	}
	
	setInnerHTML('flowCellName', Main.encodeTags(flowCell.name));

	if (flowCell.externalId != info.FlowCellID)
	{
		setInputStatus('externalId', 'Not same as registered barcode ('+flowCell.externalId+').', 'warning');
	}
	
	if (flowCell.SequencingCycles != info.SequencingCycles)
	{
		setInputStatus('sequencingCycles', 'Not same as planned SequencingCycles ('+flowCell.SequencingCycles+').', 'warning');
	}

	
	var pools = flowCell.pools;
	var html = '';
	var libPlateHtml = '';
	for (var poolNo = 0; poolNo < pools.length; poolNo++)
	{
		var pool = pools[poolNo];
		if (poolNo > 0) html += ', ';
		html += Main.encodeTags(pool.name);
		if (pool.LibPlate && libPlateHtml.indexOf(pool.LibPlate.name) == -1)
		{
			if (libPlateHtml.length > 0) libPlateHtml += ', ';
			libPlateHtml += Main.encodeTags(pool.LibPlate.name);
		}
	}
	setInnerHTML('pools', html);
	setInnerHTML('libPlate', libPlateHtml || 'n/a');

	var html = '';
	html += '<tr valign="top" class="fc-info">';
	html += '<td class="prompt" colspan="2">Existing sequencing runs</td>';
	html += '';
	html += '<td class="status"></td>';
	html += '<td class="help">Start and end date is shown for other registered sequencing runs.</td>';
	html += '</tr>';

	var seqRuns = getSequencingRunsForFlowCell(flowCell);
	var runExists = null;
	if (seqRuns.length > 0)
	{
		for (var seqNo = 0; seqNo < seqRuns.length; seqNo++)
		{
			var seqRun = seqRuns[seqNo];
			html += '<tr valign="top" class="fc-info">';
			html += '<td class="subprompt">'+seqRun.name+'</td>';
			html += '<td class="input" colspan="2">';
			html += formatDate(seqRun.SequencingStart, '(no start date)') + ' -- ' + formatDate(seqRun.SequencingEnd, '(no end date)');
			if (seqRun.SequencingResult)
			{
				html += ': ' + seqRun.SequencingResult;
			}
			html += '</td>';
			html += '<td class="help"></td>';
			html += '</tr>';
			if (seqRun.DataFilesFolder == info.RunID)
			{
				runExists = seqRun;
			}
		}
	}
	else
	{
		html += '<tr valign="top" class="fc-info">';
		html += '<td class="subprompt"></td>';
		html += '<td class="input" colspan="2">';
		html += 'none';
		html += '</td>';
		html += '<td class="help"></td>';
		html += '</tr>';
		
	}
	Main.show('existing-sequencing-runs');
	setInnerHTML('existing-sequencing-runs', html);
	if (runExists != null)
	{
		throw 'This sequencing run has already been registered: ' + runExists.name;
	}
	
}

function getFlowCellInfoByBarcode(barcode)
{
	var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetFlowCellByBarcode';
	url += '&barcode='+encodeURIComponent(barcode);
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Checking flow cell id...');
		request.open("GET", url, false);
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);

	if (response.status != 'ok')
	{
		throw response.message;
	}

	return response.flowCell;
}

function getSequencingRunsForFlowCell(flowCell)
{
	var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=GetSequencingRunsForFlowCell';
	url += '&flowCell='+flowCell.id;
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading sequencing runs...');
		request.open("GET", url, false);
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);

	if (response.status != 'ok')
	{
		throw response.message;
	}

	return response.sequencingRuns;
}

function formatDate(value, defaultValue)
{
	if (!value) return defaultValue || '';
	if (value.length == 8)
	{
		// YYYYMMDD
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	else if (value.length == 13)
	{
		// YYYYMMDD HHMM
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2) + ' ' + value.substr(9, 2) + ':' + value.substr(11, 2);
	}
	return value;
}


function goRegister()
{
	if (!step1IsValid()) return;
	var frm = document.forms['reggie'];

	frm.sequencingOperator.disabled = true;
	frm.sequencer.disabled = true;
	frm.sequencingProtocol.disabled = true;
	frm.comments.disabled = true;
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var submitInfo = {};
	submitInfo.flowCell = flowCell;
	submitInfo.runParameters = runParameters;
	
	var sequencingRun = {};
	sequencingRun.operator = frm.sequencingOperator.value;
	sequencingRun.sequencer = parseInt(frm.sequencer.value);
	sequencingRun.protocol = parseInt(frm.sequencingProtocol.value);
	sequencingRun.comments = frm.comments.value;
	submitInfo.sequencingRun = sequencingRun;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=RegisterSequencingStarted';
	var request = Ajax.getXmlHttpRequest();
	
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}

</script>
<style>

.fc-info
{
	background-color: #F4F4F4;
}

.fc-info .subprompt
{
	font-weight: normal;
	padding-left: 2em;
	text-align: left;
}

.fc-info .input
{
	font-style: italic;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register sequencing started" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Sequencing startup information</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="sequencingOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 90%;" maxlength="255" onkeypress="focusOnEnter(event, 'sequencer')">
				</td>
				<td class="status" id="sequencingOperator.status"></td>
				<td class="help">
					<span id="sequencingOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Sequencing machine</td>
				<td class="input"><select style="width:90%" name="sequencer" id="sequencer" 
					onkeypress="focusOnEnter(event, 'sequencingProtocol')"></select></td>
				<td class="status" id="sequencer.status"></td>
				<td class="help"><span id="sequencer.message" class="message" style="display: none;"></span>
					Select the HiSeq machine which is used for sequencing.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input"><select style="width:90%" name="sequencingProtocol" id="sequencingProtocol" 
					onkeypress="focusOnEnter(event, 'fc-0.externalId')"></select></td>
				<td class="status" id="sequencingProtocol.status"></td>
				<td class="help"><span id="sequencingProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used in the clustering.
				</td>
			</tr>
			<tr valign="baseline">
				<td class="prompt">runParameters.xml</td>
				<td class="input">
					<input type="file" multiple class="required" name="runParametersXml" onchange="runParametersXmlFileOnChange(event)" style="width: 90%;">
				</td>
				<td class="status" id="runParametersXml.status"></td>
				<td class="help" rowspan="4"><span id="runParametersXml.message" class="message" style="display:none;"></span>
					Select the <b>runParameters.xml</b> file that was created by the HiSeq. Typically found 
					on drive <b>D: or E:</b> in <b>\Illumina\HiSeqTemp\&lt;run-folder&gt;</b> subfolder.
				</td>
			</tr>
			<tr valign="top" class="fc-info" style="border-top: 1em solid transparent;">
				<td class="prompt" colspan="2">Sequencing information</td>
				<td class="status"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Experiment</td>
				<td class="input" id="experimentName"></td>
				<td class="status"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">RunID</td>
				<td class="input" id="runId"></td>
				<td class="status"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Barcode</td>
				<td class="input" id="externalId"></td>
				<td class="status" id="externalId.status"></td>
				<td class="help"><span id="externalId.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">HiSeq position</td>
				<td class="input" id="position"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Run number</td>
				<td class="input" id="runNumber"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Start date</td>
				<td class="input" id="startDate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Sequencing cycles</td>
				<td class="input" id="sequencingCycles"></td>
				<td class="status" id="sequencingCycles.status"></td>
				<td class="help"><span id="sequencingCycles.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="prompt" colspan="2" id="flowCellName">Flow cell information</td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">Pools</td>
				<td class="input" id="pools"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top" class="fc-info">
				<td class="subprompt">LibPlate</td>
				<td class="input" id="libPlate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tbody id="existing-sequencing-runs" style="border-bottom: 1em solid transparent;">
			<tr valign="top" class="fc-info">
				<td class="subprompt"></td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea rows="6" cols="50" style="width: 95%;" name="comments"></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help"><span id="comments.message" class="message" style="display: none;"></span>
					Comments about the sequencing startup.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>